=== debian/changelog ===
hipblas (5.5.1-1) unstable; urgency=medium

  * New upstream version 5.5.1
  * d/rules: enable verbose sphinx build
  * Fix FTBFS with Sphinx 7.1 by specifying full filepath to local
    copy of MathJax.js (Closes: #1042653).

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 02 Aug 2023 17:13:35 -0600

hipblas (5.3.3-4) unstable; urgency=medium

  * hipblas-test is now linked against generic LAPACK and BLAS, rather
    than specifically being linked against OpenBLAS. The tests can be
    sensitive to differing implementations, so use of the Netlib
    reference implementation is recommended.

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 14 Jul 2023 01:15:47 -0600

hipblas (5.3.3-3) unstable; urgency=medium

  * Restrict autopkgtests to amd64

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 07 Jul 2023 01:36:36 -0600

hipblas (5.3.3-2) unstable; urgency=medium

  * Upload to unstable
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Fri, 16 Jun 2023 08:49:06 +0200
