=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipblas-$1.tar.gz%" \
    https://github.com/rocmsoftwareplatform/hipblas/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
